import type { AstroMiddlewareInstance, ComponentInstance, RouteData } from '../../../@types/astro';
import type { DevelopmentEnvironment } from './environment';
export { createDevelopmentEnvironment } from './environment.js';
export type { DevelopmentEnvironment };
export interface SSROptions {
    /** The environment instance */
    env: DevelopmentEnvironment;
    /** location of file on disk */
    filePath: URL;
    /** production website */
    origin: string;
    /** the web request (needed for dynamic routes) */
    pathname: string;
    /** The runtime component instance */
    preload: ComponentInstance;
    /** Request */
    request: Request;
    /** optional, in case we need to render something outside of a dev server */
    route?: RouteData;
    /**
     * Optional middlewares
     */
    middleware?: AstroMiddlewareInstance<unknown>;
}
export declare function preload({ env, filePath, }: {
    env: DevelopmentEnvironment;
    filePath: URL;
}): Promise<ComponentInstance>;
export declare function renderPage(options: SSROptions): Promise<Response>;
